"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var conformPath = require('../conformPath');

var packageJSONTemplate = {
  "main": "index.js",
  "dependencies": {
    //"next": "^2.4.1",
    "next": "beta", // To allow version 3 with static building
    //"postcss-loader": "^2.0.3",
    "react": "^15.5.4",
    "react-dom": "^15.5.4"
  },
  "scripts": {
    "dev": "next",
    "build": "node_modules/.bin/next build",
    "build:static": "node_modules/.bin/next build && node_modules/.bin/next export",
    "start": "node_modules/.bin/next start"
  }
};

function pageContent(pageHTML) {
  var _pageHTML$split = pageHTML.split(/<body[^>]*>/),
      _pageHTML$split2 = _slicedToArray(_pageHTML$split, 2),
      headHTML = _pageHTML$split2[0],
      innerHTML = _pageHTML$split2[1];

  headHTML = headHTML.replace(/[\s\S]*<head>/, '');
  headHTML = headHTML.replace('</head>', '');
  // Add closing /> for JSX, e.g. <link> => <link />
  headHTML = headHTML.replace(/<link([^>]+)>/g, '<link$1/>');
  headHTML = headHTML.replace(/<meta([^>]+)>/g, '<meta$1/>');
  headHTML = headHTML.trim();

  //let innerHTML = pageHTML.replace(/[\s\S]*<body[^>]*>/, '')

  innerHTML = innerHTML.replace(/(<\/body>[\s\S]*)$/, '');

  // Add closing /> for JSX, e.g. <img> => <img />
  innerHTML = innerHTML.replace(/<img([^>]+)>/g, '<img$1/>');
  innerHTML = innerHTML.replace(/<br([^>]+)>/g, '<br$1/>');
  innerHTML = innerHTML.replace(/<hr([^>]+)>/g, '<hr$1/>');
  innerHTML = innerHTML.replace(/<input([^>]+)>/g, '<input$1/>');

  innerHTML = innerHTML.replace(/ class="/g, ' className="');
  //innerHTML = innerHTML.replace('<a>', '<Link><a>')

  return "import Link from 'next/link'\nimport Head from 'next/head'\n\nexport default ({\n  url\n}) => (\n  <div>\n    <Head>\n      " + headHTML + "\n    </Head>\n    " + innerHTML.trim() + "\n  </div>\n)";
}

function promiseFileContentsForRoutes(routes) {
  var fileContentsPromises = [Promise.resolve({
    "package.json": JSON.stringify(packageJSONTemplate, null, 2)
  })];

  routes.forEach(function (_ref) {
    var path = _ref.path,
        handler = _ref.handler;

    if (conformPath(path) !== path) {
      return;
    }

    fileContentsPromises.push(new Promise(function (resolve, reject) {
      handler({}, function (result) {
        if (result instanceof Error) {
          reject(result);
        } else {
          Promise.resolve(result).then(function (html) {
            resolve(_defineProperty({}, "pages" + conformPath(path) + "index.js", pageContent(html)));
          }).catch(reject);
        }
      });
    }));
  });

  return Promise.all(fileContentsPromises).then(function (objects) {
    return Object.assign.apply(Object, [{}].concat(objects));
  });
}

module.exports = {
  promiseFileContentsForRoutes: promiseFileContentsForRoutes
};