'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var conformPath = require('../conformPath');

function promiseFileContentsForRoutes(routes) {
  var fileContentsPromises = [];
  routes.forEach(function (_ref) {
    var path = _ref.path,
        handler = _ref.handler;

    if (conformPath(path) !== path) {
      return;
    }

    fileContentsPromises.push(new Promise(function (resolve, reject) {
      handler({}, function (result) {
        if (result instanceof Error) {
          reject(result);
        } else {
          Promise.resolve(result).then(function (html) {
            resolve(_defineProperty({}, conformPath(path).substring(1) + 'index.html', html));
          }).catch(reject);
        }
      });
    }));
  });

  return Promise.all(fileContentsPromises).then(function (objects) {
    return Object.assign.apply(Object, [{}].concat(objects));
  });
}

module.exports = {
  promiseFileContentsForRoutes: promiseFileContentsForRoutes
};